<template>
  <a-icon-select-ui
    class="[ bh-filter-ui ]"
    multiple
    :options="options"
    :selected="selected"
    track-by="code"
    disable-by="disabled"
    :position="panelPosition"
    :style="{
      '--a-icon-select-ui--panel--mt': 'var(--bh-container--row-gap)',
      '--a-icon-select-ui--panel--max-h': 'var(--bh-bizcard-list-area--h)',
      '--a-icon-select-ui--panel--min-w': 'var(--bh-filters-area--w)',
    }"
    @changed="$emit('changed', $event)"
  >
    <template #icon="{ hasSelected, reset }">
      <bh-filter-button-ui
        class="rounded-l"
        aria-label="Reset"
        :active="active"
        :inverted="hasSelected"
        :disabled="!hasSelected"
        @click="reset()"
      >
        <slot name="icon" />
      </bh-filter-button-ui>
    </template>

    <template #caret="{ isOpen }">
      <bh-filter-button-ui
        class="-ml-px rounded-r"
        aria-label="Open"
        :active="active"
      >
        <svg-icon
          name="app/chevron-down"
          class="[ h-6 w-6 ][ transition duration-150 ease-in-out ]"
          :data-caret-direction="active && isOpen ? 'up' : 'down'"
        />
      </bh-filter-button-ui>
    </template>

    <template #option="{ option, isSelected, isDisabled }">
      <slot name="option" v-bind="{ option, isSelected, isDisabled }" />
    </template>
  </a-icon-select-ui>
</template>

<script>
export default {
  name: 'BhFilterUi',
  props: {
    options: {
      type: Array,
      default: () => [],
    },
    selected: {
      type: Array,
      default: () => [],
    },
    panelPosition: {
      type: String,
      default: 'left',
      validator: (value) => ['left', 'center', 'right'].includes(value),
    },
  },
  computed: {
    active() {
      return !!this.options.length;
    },
  },
};
</script>

<style lang="postcss" scoped>
.bh-filter-ui [data-caret-direction='up'] {
  @apply transform rotate-180;
}
</style>
